function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import classNames from 'classnames';
import Day from '../Day';
import format from 'date-fns/format';
import getDay from 'date-fns/get_day';
import isSameYear from 'date-fns/is_same_year';
var styles = {
  'root': 'Cal__Month__root',
  'rows': 'Cal__Month__rows',
  'row': 'Cal__Month__row',
  'partial': 'Cal__Month__partial',
  'label': 'Cal__Month__label',
  'partialFirstRow': 'Cal__Month__partialFirstRow'
};

var Month = function (_Component) {
  _inherits(Month, _Component);

  function Month() {
    _classCallCheck(this, Month);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Month.prototype.renderRows = function renderRows() {
    var _props = this.props,
        disabledDates = _props.disabledDates,
        disabledDays = _props.disabledDays,
        displayDate = _props.displayDate,
        locale = _props.locale,
        maxDate = _props.maxDate,
        minDate = _props.minDate,
        onDaySelect = _props.onDaySelect,
        rowHeight = _props.rowHeight,
        rows = _props.rows,
        selectedDate = _props.selectedDate,
        today = _props.today,
        theme = _props.theme;

    var currentYear = today.getFullYear();
    var year = displayDate.getFullYear();
    var month = displayDate.getMonth();
    var monthShort = format(displayDate, 'MMM', { locale: locale.locale });
    var monthRows = [];
    var day = 0;
    var isDisabled = false;
    var isSelected = false;
    var isToday = false;
    var date = void 0,
        days = void 0,
        dow = void 0,
        row = void 0;

    // Used for faster comparisons
    var _selected = format(selectedDate, 'YYYY-MM-DD');
    var _today = format(today, 'YYYY-MM-DD');
    var _minDate = format(minDate, 'YYYY-MM-DD');
    var _maxDate = format(maxDate, 'YYYY-MM-DD');

    // Oh the things we do in the name of performance...
    for (var i = 0, len = rows.length; i < len; i++) {
      var _classNames;

      row = rows[i];
      days = [];
      dow = getDay(new Date(year, month, row[0]));

      for (var k = 0, _len = row.length; k < _len; k++) {
        day = row[k];

        date = year + '-' + ('0' + (month + 1)).slice(-2) + '-' + ('0' + day).slice(-2);
        isSelected = date === _selected;
        isToday = date === _today;

        isDisabled = minDate && date < _minDate || maxDate && date > _maxDate || disabledDays && disabledDays.length && disabledDays.indexOf(dow) !== -1 || disabledDates && disabledDates.length && disabledDates.indexOf(date) !== -1;

        days[k] = React.createElement(Day, {
          key: 'day-' + day,
          currentYear: currentYear,
          year: year,
          date: date,
          day: day,
          onClick: onDaySelect,
          isDisabled: isDisabled,
          isToday: isToday,
          isSelected: isSelected,
          locale: locale,
          monthShort: monthShort,
          theme: theme
        });

        dow += 1;
      }
      monthRows[i] = React.createElement(
        'ul',
        { className: classNames(styles.row, (_classNames = {}, _classNames[styles.partial] = row.length !== 7, _classNames)), style: { height: rowHeight }, key: 'Row-' + i, role: 'row', 'aria-label': 'Week ' + (i + 1) },
        days
      );
    }

    return monthRows;
  };

  Month.prototype.render = function render() {
    var _classNames2;

    var _props2 = this.props,
        displayDate = _props2.displayDate,
        today = _props2.today,
        rows = _props2.rows,
        showOverlay = _props2.showOverlay,
        style = _props2.style,
        theme = _props2.theme;


    return React.createElement(
      'div',
      { className: styles.root, style: style },
      React.createElement(
        'div',
        { className: styles.rows },
        this.renderRows(),
        showOverlay && React.createElement(
          'label',
          {
            className: classNames(styles.label, (_classNames2 = {}, _classNames2[styles.partialFirstRow] = rows[0].length !== 7, _classNames2)),
            style: { backgroundColor: theme.overlayColor }
          },
          React.createElement(
            'span',
            null,
            '' + format(displayDate, 'MMMM') + (!isSameYear(displayDate, today) ? ' ' + displayDate.getFullYear() : '')
          )
        )
      )
    );
  };

  return Month;
}(Component);

export { Month as default };