function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component, PropTypes } from 'react';
import { List } from 'react-virtualized';
import classNames from 'classnames';
import { getMonth, getWeeksInMonth } from '../utils';
import differenceInWeeks from 'date-fns/difference_in_weeks';
import differenceInMonths from 'date-fns/difference_in_months';
import startOfMonth from 'date-fns/start_of_month';
import Month from '../Month';
var styles = {
  'root': 'Cal__MonthList__root',
  'scrolling': 'Cal__MonthList__scrolling'
};

import overscanIndicesGetter from './overscanIndicesGetter';

var MonthList = function (_Component) {
  _inherits(MonthList, _Component);

  function MonthList() {
    var _temp, _this, _ret;

    _classCallCheck(this, MonthList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.cache = {}, _this.state = {}, _this.memoize = function (param) {
      if (!this.cache[param]) {
        var weekStartsOn = this.props.locale.weekStartsOn;

        var _param$split = param.split(':'),
            year = _param$split[0],
            month = _param$split[1];

        var result = getMonth(year, month, weekStartsOn);
        this.cache[param] = result;
      }
      return this.cache[param];
    }, _this.monthHeights = [], _this.getMonthHeight = function (_ref) {
      var index = _ref.index;

      if (!_this.monthHeights[index]) {
        var _this$props = _this.props,
            weekStartsOn = _this$props.locale.weekStartsOn,
            months = _this$props.months,
            rowHeight = _this$props.rowHeight;
        var _months$index = months[index],
            month = _months$index.month,
            year = _months$index.year;

        var weeks = getWeeksInMonth(month, year, weekStartsOn);
        var height = weeks * rowHeight;
        _this.monthHeights[index] = height;
      }

      return _this.monthHeights[index];
    }, _this.getMonthIndex = function (date) {
      var min = _this.props.min;

      var index = differenceInMonths(min, date);

      return index;
    }, _this.getDateOffset = function (date) {
      var _this$props2 = _this.props,
          min = _this$props2.min,
          rowHeight = _this$props2.rowHeight;

      var weeks = differenceInWeeks(startOfMonth(date), startOfMonth(min));

      return weeks * rowHeight;
    }, _this.getCurrentOffset = function () {
      if (_this.scrollEl) {
        return _this.scrollEl.scrollTop;
      }
    }, _this.scrollToDate = function (date) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var offsetTop = _this.getDateOffset(date);
      _this.scrollTo(offsetTop + offset);
    }, _this.scrollTo = function () {
      var scrollTop = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (_this.scrollEl) {
        _this.scrollEl.style.overflowY = 'hidden';

        window.requestAnimationFrame(function () {
          _this.scrollEl.scrollTop = scrollTop;

          setTimeout(function () {
            _this.scrollEl.style.overflowY = 'auto';
          });
        });
      }
    }, _this.renderMonth = function (_ref2) {
      var index = _ref2.index,
          isScrolling = _ref2.isScrolling,
          style = _ref2.style;
      var _this$props3 = _this.props,
          disabledDates = _this$props3.disabledDates,
          disabledDays = _this$props3.disabledDays,
          locale = _this$props3.locale,
          maxDate = _this$props3.maxDate,
          minDate = _this$props3.minDate,
          months = _this$props3.months,
          onDaySelect = _this$props3.onDaySelect,
          rowHeight = _this$props3.rowHeight,
          selectedDate = _this$props3.selectedDate,
          showOverlay = _this$props3.showOverlay,
          theme = _this$props3.theme,
          today = _this$props3.today;
      var _months$index2 = months[index],
          month = _months$index2.month,
          year = _months$index2.year;

      var key = year + ':' + month;

      var _this$memoize = _this.memoize(key),
          date = _this$memoize.date,
          rows = _this$memoize.rows;

      return React.createElement(Month, {
        key: key,
        selectedDate: selectedDate,
        displayDate: date,
        disabledDates: disabledDates,
        disabledDays: disabledDays,
        maxDate: maxDate,
        minDate: minDate,
        onDaySelect: onDaySelect,
        rows: rows,
        rowHeight: rowHeight,
        isScrolling: isScrolling,
        showOverlay: showOverlay,
        today: today,
        theme: theme,
        locale: locale,
        style: style
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  MonthList.prototype.componentDidMount = function componentDidMount() {
    var list = this.refs.List;
    var grid = list && list.Grid;

    this.scrollEl = grid && grid._scrollingContainer;
  };

  MonthList.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        height = _props.height,
        isScrolling = _props.isScrolling,
        onScroll = _props.onScroll,
        overscanMonthCount = _props.overscanMonthCount,
        months = _props.months,
        rowHeight = _props.rowHeight,
        selectedDate = _props.selectedDate,
        today = _props.today,
        width = _props.width;

    if (!this._initScrollTop) this._initScrollTop = this.getDateOffset(selectedDate || today);

    return React.createElement(
      'div',
      { onClick: this.handleClick },
      React.createElement(List, {
        ref: 'List',
        width: width,
        height: height,
        rowCount: months.length,
        rowHeight: this.getMonthHeight,
        estimatedRowSize: rowHeight * 5,
        rowRenderer: this.renderMonth,
        onScroll: onScroll,
        scrollTop: this._initScrollTop,
        className: classNames(styles.root, (_classNames = {}, _classNames[styles.scrolling] = isScrolling, _classNames)),
        style: { lineHeight: rowHeight + 'px' },
        overscanRowCount: overscanMonthCount,
        overscanIndicesGetter: overscanIndicesGetter
      })
    );
  };

  return MonthList;
}(Component);

export { MonthList as default };
process.env.NODE_ENV !== "production" ? MonthList.propTypes = {
  disabledDates: PropTypes.arrayOf(PropTypes.string),
  disabledDays: PropTypes.arrayOf(PropTypes.number),
  height: PropTypes.number,
  isScrolling: PropTypes.bool,
  locale: PropTypes.object,
  maxDate: PropTypes.instanceOf(Date),
  min: PropTypes.instanceOf(Date),
  minDate: PropTypes.instanceOf(Date),
  months: PropTypes.arrayOf(PropTypes.object),
  onDaySelect: PropTypes.func,
  onScroll: PropTypes.func,
  overscanMonthCount: PropTypes.number,
  rowHeight: PropTypes.number,
  selectedDate: PropTypes.instanceOf(Date),
  showOverlay: PropTypes.bool,
  theme: PropTypes.object,
  today: PropTypes.instanceOf(Date),
  width: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
} : void 0;