'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCssTransitionGroup = require('react-addons-css-transition-group');

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _format = require('date-fns/format');

var _format2 = _interopRequireDefault(_format);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  'root': 'Cal__Header__root',
  'blank': 'Cal__Header__blank',
  'wrapper': 'Cal__Header__wrapper',
  'landscape': 'Cal__Header__landscape',
  'dateWrapper': 'Cal__Header__dateWrapper',
  'day': 'Cal__Header__day',
  'active': 'Cal__Header__active',
  'year': 'Cal__Header__year',
  'date': 'Cal__Header__date'
};
var animation = {
  'enter': 'Cal__Animation__enter',
  'enterActive': 'Cal__Animation__enterActive',
  'leave': 'Cal__Animation__leave',
  'leaveActive': 'Cal__Animation__leaveActive'
};

var Header = function (_PureComponent) {
  _inherits(Header, _PureComponent);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, _PureComponent.apply(this, arguments));
  }

  Header.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        display = _props.display,
        layout = _props.layout,
        _props$locale = _props.locale,
        blank = _props$locale.blank,
        headerFormat = _props$locale.headerFormat,
        locale = _props$locale.locale,
        scrollToDate = _props.scrollToDate,
        selectedDate = _props.selectedDate,
        setDisplay = _props.setDisplay,
        shouldHeaderAnimate = _props.shouldHeaderAnimate,
        theme = _props.theme;

    var values = selectedDate && [{
      active: display === 'years',
      handleClick: function handleClick(e) {
        e && e.stopPropagation();
        setDisplay('years');
      },
      item: 'year',
      title: display === 'days' ? 'Change year' : null,
      value: selectedDate.getFullYear()
    }, {
      active: display === 'days',
      handleClick: function handleClick(e) {
        e && e.stopPropagation();

        if (display !== 'days') {
          setDisplay('days');
        } else if (selectedDate) {
          scrollToDate(selectedDate, -40);
        }
      },
      item: 'day',
      key: (0, _format2.default)(selectedDate, 'YYYYMMDD', { locale: locale }),
      title: display === 'days' ? 'Scroll to ' + (0, _format2.default)(_format2.default, headerFormat, { locale: locale }) : null,
      value: (0, _format2.default)(selectedDate, headerFormat, { locale: locale })
    }];

    return _react2.default.createElement(
      'div',
      {
        className: (0, _classnames2.default)(styles.root, (_classNames = {}, _classNames[styles.blank] = !selectedDate, _classNames[styles.landscape] = layout === 'landscape', _classNames)),
        style: {
          backgroundColor: theme.headerColor,
          color: theme.textColor.active
        }
      },
      selectedDate ? _react2.default.createElement(
        'div',
        {
          className: styles.wrapper,
          'aria-label': (0, _format2.default)(_format2.default, headerFormat + ' YYYY', { locale: locale })
        },
        values.map(function (_ref) {
          var _classNames2;

          var handleClick = _ref.handleClick,
              item = _ref.item,
              key = _ref.key,
              value = _ref.value,
              active = _ref.active,
              title = _ref.title;

          return _react2.default.createElement(
            'div',
            {
              key: item,
              className: (0, _classnames2.default)(styles.dateWrapper, styles[item], (_classNames2 = {}, _classNames2[styles.active] = active, _classNames2)),
              title: title
            },
            _react2.default.createElement(
              _reactAddonsCssTransitionGroup2.default,
              {
                transitionName: animation,
                transitionEnterTimeout: 250,
                transitionLeaveTimeout: 250,
                transitionEnter: shouldHeaderAnimate,
                transitionLeave: shouldHeaderAnimate
              },
              _react2.default.createElement(
                'span',
                {
                  key: item + '-' + (key || value),
                  className: styles.date,
                  'aria-hidden': true,
                  onClick: handleClick
                },
                value
              )
            )
          );
        })
      ) : _react2.default.createElement(
        'div',
        { className: styles.wrapper },
        blank
      )
    );
  };

  return Header;
}(_react.PureComponent);

exports.default = Header;
process.env.NODE_ENV !== "production" ? Header.propTypes = {
  display: _react.PropTypes.string,
  layout: _react.PropTypes.string,
  locale: _react.PropTypes.object,
  onClick: _react.PropTypes.func,
  selectedDate: _react.PropTypes.oneOfType([_react.PropTypes.instanceOf(Date), _react.PropTypes.bool]),
  shouldHeaderAnimate: _react.PropTypes.bool,
  theme: _react.PropTypes.object
} : void 0;
module.exports = exports['default'];