'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactVirtualized = require('react-virtualized');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../utils');

var _difference_in_weeks = require('date-fns/difference_in_weeks');

var _difference_in_weeks2 = _interopRequireDefault(_difference_in_weeks);

var _difference_in_months = require('date-fns/difference_in_months');

var _difference_in_months2 = _interopRequireDefault(_difference_in_months);

var _start_of_month = require('date-fns/start_of_month');

var _start_of_month2 = _interopRequireDefault(_start_of_month);

var _Month = require('../Month');

var _Month2 = _interopRequireDefault(_Month);

var _overscanIndicesGetter = require('./overscanIndicesGetter');

var _overscanIndicesGetter2 = _interopRequireDefault(_overscanIndicesGetter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  'root': 'Cal__MonthList__root',
  'scrolling': 'Cal__MonthList__scrolling'
};

var MonthList = function (_Component) {
  _inherits(MonthList, _Component);

  function MonthList() {
    var _temp, _this, _ret;

    _classCallCheck(this, MonthList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.cache = {}, _this.state = {}, _this.memoize = function (param) {
      if (!this.cache[param]) {
        var weekStartsOn = this.props.locale.weekStartsOn;

        var _param$split = param.split(':'),
            year = _param$split[0],
            month = _param$split[1];

        var result = (0, _utils.getMonth)(year, month, weekStartsOn);
        this.cache[param] = result;
      }
      return this.cache[param];
    }, _this.monthHeights = [], _this.getMonthHeight = function (_ref) {
      var index = _ref.index;

      if (!_this.monthHeights[index]) {
        var _this$props = _this.props,
            weekStartsOn = _this$props.locale.weekStartsOn,
            months = _this$props.months,
            rowHeight = _this$props.rowHeight;
        var _months$index = months[index],
            month = _months$index.month,
            year = _months$index.year;

        var weeks = (0, _utils.getWeeksInMonth)(month, year, weekStartsOn);
        var height = weeks * rowHeight;
        _this.monthHeights[index] = height;
      }

      return _this.monthHeights[index];
    }, _this.getMonthIndex = function (date) {
      var min = _this.props.min;

      var index = (0, _difference_in_months2.default)(min, date);

      return index;
    }, _this.getDateOffset = function (date) {
      var _this$props2 = _this.props,
          min = _this$props2.min,
          rowHeight = _this$props2.rowHeight;

      var weeks = (0, _difference_in_weeks2.default)((0, _start_of_month2.default)(date), (0, _start_of_month2.default)(min));

      return weeks * rowHeight;
    }, _this.getCurrentOffset = function () {
      if (_this.scrollEl) {
        return _this.scrollEl.scrollTop;
      }
    }, _this.scrollToDate = function (date) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var offsetTop = _this.getDateOffset(date);
      _this.scrollTo(offsetTop + offset);
    }, _this.scrollTo = function () {
      var scrollTop = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (_this.scrollEl) {
        _this.scrollEl.style.overflowY = 'hidden';

        window.requestAnimationFrame(function () {
          _this.scrollEl.scrollTop = scrollTop;

          setTimeout(function () {
            _this.scrollEl.style.overflowY = 'auto';
          });
        });
      }
    }, _this.renderMonth = function (_ref2) {
      var index = _ref2.index,
          isScrolling = _ref2.isScrolling,
          style = _ref2.style;
      var _this$props3 = _this.props,
          disabledDates = _this$props3.disabledDates,
          disabledDays = _this$props3.disabledDays,
          locale = _this$props3.locale,
          maxDate = _this$props3.maxDate,
          minDate = _this$props3.minDate,
          months = _this$props3.months,
          onDaySelect = _this$props3.onDaySelect,
          rowHeight = _this$props3.rowHeight,
          selectedDate = _this$props3.selectedDate,
          showOverlay = _this$props3.showOverlay,
          theme = _this$props3.theme,
          today = _this$props3.today;
      var _months$index2 = months[index],
          month = _months$index2.month,
          year = _months$index2.year;

      var key = year + ':' + month;

      var _this$memoize = _this.memoize(key),
          date = _this$memoize.date,
          rows = _this$memoize.rows;

      return _react2.default.createElement(_Month2.default, {
        key: key,
        selectedDate: selectedDate,
        displayDate: date,
        disabledDates: disabledDates,
        disabledDays: disabledDays,
        maxDate: maxDate,
        minDate: minDate,
        onDaySelect: onDaySelect,
        rows: rows,
        rowHeight: rowHeight,
        isScrolling: isScrolling,
        showOverlay: showOverlay,
        today: today,
        theme: theme,
        locale: locale,
        style: style
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  MonthList.prototype.componentDidMount = function componentDidMount() {
    var list = this.refs.List;
    var grid = list && list.Grid;

    this.scrollEl = grid && grid._scrollingContainer;
  };

  MonthList.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        height = _props.height,
        isScrolling = _props.isScrolling,
        onScroll = _props.onScroll,
        overscanMonthCount = _props.overscanMonthCount,
        months = _props.months,
        rowHeight = _props.rowHeight,
        selectedDate = _props.selectedDate,
        today = _props.today,
        width = _props.width;

    if (!this._initScrollTop) this._initScrollTop = this.getDateOffset(selectedDate || today);

    return _react2.default.createElement(
      'div',
      { onClick: this.handleClick },
      _react2.default.createElement(_reactVirtualized.List, {
        ref: 'List',
        width: width,
        height: height,
        rowCount: months.length,
        rowHeight: this.getMonthHeight,
        estimatedRowSize: rowHeight * 5,
        rowRenderer: this.renderMonth,
        onScroll: onScroll,
        scrollTop: this._initScrollTop,
        className: (0, _classnames2.default)(styles.root, (_classNames = {}, _classNames[styles.scrolling] = isScrolling, _classNames)),
        style: { lineHeight: rowHeight + 'px' },
        overscanRowCount: overscanMonthCount,
        overscanIndicesGetter: _overscanIndicesGetter2.default
      })
    );
  };

  return MonthList;
}(_react.Component);

exports.default = MonthList;
process.env.NODE_ENV !== "production" ? MonthList.propTypes = {
  disabledDates: _react.PropTypes.arrayOf(_react.PropTypes.string),
  disabledDays: _react.PropTypes.arrayOf(_react.PropTypes.number),
  height: _react.PropTypes.number,
  isScrolling: _react.PropTypes.bool,
  locale: _react.PropTypes.object,
  maxDate: _react.PropTypes.instanceOf(Date),
  min: _react.PropTypes.instanceOf(Date),
  minDate: _react.PropTypes.instanceOf(Date),
  months: _react.PropTypes.arrayOf(_react.PropTypes.object),
  onDaySelect: _react.PropTypes.func,
  onScroll: _react.PropTypes.func,
  overscanMonthCount: _react.PropTypes.number,
  rowHeight: _react.PropTypes.number,
  selectedDate: _react.PropTypes.instanceOf(Date),
  showOverlay: _react.PropTypes.bool,
  theme: _react.PropTypes.object,
  today: _react.PropTypes.instanceOf(Date),
  width: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string])
} : void 0;
module.exports = exports['default'];